#ifndef __MYCT_IIC_H
#define __MYCT_IIC_H
#include "sys.h"	    	

//IO
#define CT_SDA_IN()  {GPIOF->MODER&=~(3<<(2*11));GPIOF->MODER|=0<<2*11;}	//PF11ģʽ
#define CT_SDA_OUT() {GPIOF->MODER&=~(3<<(2*11));GPIOF->MODER|=1<<2*11;} 	//PF11ģʽ
//IO	 
#define CT_IIC_SCL    PBout(0) 	//SCL
#define CT_IIC_SDA    PFout(11) //SDA	 
#define CT_READ_SDA   PFin(11)  //SDA 
 

//IICв
void CT_IIC_Init(void);                	//ʼIICIO				 
void CT_IIC_Start(void);				//IICʼź
void CT_IIC_Stop(void);	  				//IICֹͣź
void CT_IIC_Send_Byte(u8 txd);			//IICһֽ
u8 CT_IIC_Read_Byte(unsigned char ack);	//IICȡһֽ
u8 CT_IIC_Wait_Ack(void); 				//IICȴACKź
void CT_IIC_Ack(void);					//IICACKź
void CT_IIC_NAck(void);					//IICACKź

#endif







